"""
 (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
 All Rights Reserved

 This file is part of Gideon.

 Gideon is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Gideon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Gideon; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# $Id: __init__.py,v 1.2 2002/04/09 10:21:59 ender Exp $
import PEP241Handler
import PPDHandler
import CiphonHandler

import MetaAdapter

_alookup = {}


def register_adapter(adapter):
    _alookup[adapter.name]=adapter

def supported_formats(obj):
    return _alookup.keys()

def process(type,stream):

    a = _alookup.get(type, None)
    return a.process(stream)

register_adapter(MetaAdapter.PEP241Adapter('PEP241'))
register_adapter(MetaAdapter.CiphonAdapter('CIPHON'))
register_adapter(MetaAdapter.PPDAdapter('PPD'))
