from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon.Objects.Catalog import CatalogSchema
from Products.Gideon.Objects.Authors.Authors import Author, make_author_id

from util import package_admin_home

class InfoPresentation(SimpleItem):

    id = 'Info'
    
    """
    admin ui for managing package info
    """
    
    index_html = DTMLFile(
        'ui/PackageAdminEditInfoForm',
        package_admin_home)

    
    def edit_package_info(self, REQUEST):
        """ """
        contract = """
        #parameters
        summary:trim
        license:trim, constraint(supported_licenses)
        description:trim
        homepage:trim,uri
        platform:constraint(supported_platforms)
        """
        contract = compile(contract, self)
        contract.validate(self)

        vars = contract.extract_variables(REQUEST)
        info = self.get_package_info()

        for k,v in vars.items():
            method = getattr(info, 'set_'+k, None)
            if method: method(v)
        
        history = self.get_package().get_history()
        history.add_note("edit", "package info edited")        
        REQUEST.RESPONSE.redirect('.')


