

import os
import shutil
from os.path import join, exists, isdir, getmtime

from Products.Gideon import gideon_home
from Products.Gideon.Log  import LogFactory

log = LogFactory('Simple PackageFS')

def copy_stream(instream, outstream, bufsize=8196*10):

    instream.seek(0,2)
    size = instream.tell()
    tsize = size
    instream.seek(0)

    loop = 0
    while size > 0:
        loop += 1
        print size, loop
        buf = instream.read(bufsize)
        size -= bufsize
        outstream.write(buf)

    return tsize

def copy_stream_consumer(instream, consumer, bufsize=8196*10):
    
    instream.seek(0,2)
    size = instream.tell()
    tsize = size
    instream.seek(0)

    loop = 0
    while size > 0:
        loop += 1
        print size, loop
        buf = instream.read(bufsize)
        size -= bufsize
        consumer(buf)

    return tsize


class SimplePackageFs:

    def __getitem__(self, name):
        
        bucket = name[0].lower()
        dirpath = join(packagedir,bucket,name)
        if not isdir(dirpath):
            raise "Invalid Package Directory"

        return SimpleDirectoryWrapper(dirpath)

    def add_package_directory(self, name):
        
        bucket = name[0].lower()
        os.mkdir(join(packagedir,bucket,name))

class SimpleDirectoryWrapper:

    __allow_access_to_unprotected_subobjects = 1

    def __init__(self, path):
        self.path = path
    
    def add_file_object(self, id, file):
        
        fh = open(join(self.path,id), 'w')
        copy_stream(file, fh)

    def get_file(self, name):
        
        return SimpleFileWrapper(join(self.path,name))

class SimpleFileWrapper:

    def __init__(self, path):
        
        self.path = path

    def input_stream(self):
        
        return open(self.path, 'r')

    def size(self):
        
        return os.stat(self.path)[6]

packagedir = join(gideon_home, 'var', 'packages')
package_file_system = SimplePackageFs()
